struct composite_program : ProgramImpl {
int get_uniform(const char *name) const override {
 if (strcmp("sColor0", name) == 0) { return 2; }
 if (strcmp("sColor1", name) == 0) { return 3; }
 if (strcmp("sColor2", name) == 0) { return 4; }
 if (strcmp("uTransform", name) == 0) { return 1; }
 return -1;
}
struct Samplers {
 sampler2DArray_impl sColor0_impl;
 int sColor0_slot;
 sampler2DArray_impl sColor1_impl;
 int sColor1_slot;
 sampler2DArray_impl sColor2_impl;
 int sColor2_slot;
} samplers;
bool set_sampler(int index, int value) override {
 switch (index) {
 case 2:
  samplers.sColor0_slot = value;
  return true;
 case 3:
  samplers.sColor1_slot = value;
  return true;
 case 4:
  samplers.sColor2_slot = value;
  return true;
 }
 return false;
}
struct AttribLocations {
 int aPosition = NULL_ATTRIB;
 int aDeviceRect = NULL_ATTRIB;
 int aDeviceClipRect = NULL_ATTRIB;
 int aColor = NULL_ATTRIB;
 int aParams = NULL_ATTRIB;
 int aTextureLayers = NULL_ATTRIB;
} attrib_locations;
void bind_attrib(const char* name, int index) override {
 if (strcmp("aPosition", name) == 0) { attrib_locations.aPosition = index; return; }
 if (strcmp("aDeviceRect", name) == 0) { attrib_locations.aDeviceRect = index; return; }
 if (strcmp("aDeviceClipRect", name) == 0) { attrib_locations.aDeviceClipRect = index; return; }
 if (strcmp("aColor", name) == 0) { attrib_locations.aColor = index; return; }
 if (strcmp("aParams", name) == 0) { attrib_locations.aParams = index; return; }
 if (strcmp("aTextureLayers", name) == 0) { attrib_locations.aTextureLayers = index; return; }
}
int get_attrib(const char* name) const override {
 if (strcmp("aPosition", name) == 0) {return attrib_locations.aPosition != NULL_ATTRIB ? attrib_locations.aPosition : -1;}
 if (strcmp("aDeviceRect", name) == 0) {return attrib_locations.aDeviceRect != NULL_ATTRIB ? attrib_locations.aDeviceRect : -1;}
 if (strcmp("aDeviceClipRect", name) == 0) {return attrib_locations.aDeviceClipRect != NULL_ATTRIB ? attrib_locations.aDeviceClipRect : -1;}
 if (strcmp("aColor", name) == 0) {return attrib_locations.aColor != NULL_ATTRIB ? attrib_locations.aColor : -1;}
 if (strcmp("aParams", name) == 0) {return attrib_locations.aParams != NULL_ATTRIB ? attrib_locations.aParams : -1;}
 if (strcmp("aTextureLayers", name) == 0) {return attrib_locations.aTextureLayers != NULL_ATTRIB ? attrib_locations.aTextureLayers : -1;}
  return -1;
}
VertexShaderImpl* get_vertex_shader() override;
FragmentShaderImpl* get_fragment_shader() override;
static ProgramImpl* loader() { return new composite_program; }
};

struct composite_vert : VertexShaderImpl {
typedef composite_vert Self;
int32_t uMode;
mat4_scalar uTransform;
vec2 aPosition;
sampler2DArray sColor0;
sampler2DArray sColor1;
sampler2DArray sColor2;
mat3_scalar static constexpr YuvColorMatrixRec601 = make_mat3(1.16438f, 1.16438f, 1.16438f, 0.f, -(0.39176f), 2.01723f, 1.59603f, -(0.81297f), 0.f);
mat3_scalar static constexpr YuvColorMatrixRec709 = make_mat3(1.16438f, 1.16438f, 1.16438f, 0.f, -(0.21325f), 2.1124f, 1.79274f, -(0.53291f), 0.f);
mat3_scalar static constexpr YuvColorMatrixRec2020 = make_mat3(1.16438356164384f, 1.16438356164384f, 1.16438356164384f, 0.f, -(0.187326104219343f), 2.14177232142857f, 1.67867410714286f, -(0.650424318505057f), 0.f);
vec4_scalar vColor;
float vLayer;
vec2 vUv;
vec4_scalar aDeviceRect;
vec4_scalar aDeviceClipRect;
vec4_scalar aColor;
vec4_scalar aParams;
vec3_scalar aTextureLayers;
ALWAYS_INLINE void main(void) {
 vec2 world_pos = ((aDeviceRect).sel(X, Y))+(((aPosition).sel(X, Y))*((aDeviceRect).sel(Z, W)));
 vec2 clipped_world_pos = clamp(world_pos, (aDeviceClipRect).sel(X, Y), ((aDeviceClipRect).sel(X, Y))+((aDeviceClipRect).sel(Z, W)));
 vec2 uv = ((clipped_world_pos)-((aDeviceRect).sel(X, Y)))/((aDeviceRect).sel(Z, W));
 vUv = uv;
 vColor = aColor;
 vLayer = (aTextureLayers).sel(X);
 gl_Position = (uTransform)*(make_vec4(clipped_world_pos, (aParams).sel(X), 1.f));
}
static void set_uniform_1i(Self *self, int index, int value) {
 switch (index) {
 case 1:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_matrix4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  self->uTransform = mat4_scalar::load_from_ptr(value);
  break;
 }
}
static void load_attribs(Self *self, composite_program *prog, VertexAttrib *attribs, unsigned short *indices, int start, int instance, int count) {
 load_attrib(self->aPosition, attribs[prog->attrib_locations.aPosition], indices, start, instance, count);
 load_flat_attrib(self->aDeviceRect, attribs[prog->attrib_locations.aDeviceRect], indices, start, instance, count);
 load_flat_attrib(self->aDeviceClipRect, attribs[prog->attrib_locations.aDeviceClipRect], indices, start, instance, count);
 load_flat_attrib(self->aColor, attribs[prog->attrib_locations.aColor], indices, start, instance, count);
 load_flat_attrib(self->aParams, attribs[prog->attrib_locations.aParams], indices, start, instance, count);
 load_flat_attrib(self->aTextureLayers, attribs[prog->attrib_locations.aTextureLayers], indices, start, instance, count);
}
struct FlatOutputs {
vec4_scalar vColor;
float vLayer;
};
struct InterpOutputs {
vec2_scalar vUv;
};
ALWAYS_INLINE void store_flat_outputs(char* dest_ptr) {
  auto* dest = reinterpret_cast<FlatOutputs*>(dest_ptr);
  dest->vColor = vColor;
  dest->vLayer = vLayer;
}
ALWAYS_INLINE void store_interp_outputs(char* dest_ptr, size_t stride) {
  for(int n = 0; n < 4; n++) {
    auto* dest = reinterpret_cast<InterpOutputs*>(dest_ptr);
    dest->vUv = get_nth(vUv, n);
    dest_ptr += stride;
  }
}
static void bind_textures(Self *self, composite_program *prog) {
}
static void run(Self* self, char* flats, char* interps, size_t interp_stride) {
 self->main();
 self->store_flat_outputs(flats);
 self->store_interp_outputs(interps, interp_stride);
}
composite_vert() {
 set_uniform_1i_func = (SetUniform1iFunc)&set_uniform_1i;
 set_uniform_4fv_func = (SetUniform4fvFunc)&set_uniform_4fv;
 set_uniform_matrix4fv_func = (SetUniformMatrix4fvFunc)&set_uniform_matrix4fv;
 init_batch_func = (InitBatchFunc)&bind_textures;
 load_attribs_func = (LoadAttribsFunc)&load_attribs;
 run_func = (RunFunc)&run;
}
};

VertexShaderImpl* composite_program::get_vertex_shader() { return new composite_vert; }
mat3_scalar constexpr composite_vert::YuvColorMatrixRec601;
mat3_scalar constexpr composite_vert::YuvColorMatrixRec709;
mat3_scalar constexpr composite_vert::YuvColorMatrixRec2020;

struct composite_frag : FragmentShaderImpl {
typedef composite_frag Self;
#define oFragColor gl_FragColor
// vec4 oFragColor;
sampler2DArray sColor0;
sampler2DArray sColor1;
sampler2DArray sColor2;
vec4_scalar vColor;
float vLayer;
vec2 vUv;
void write_output(vec4 color) {
 oFragColor = color;
}
ALWAYS_INLINE void main(void) {
 vec4 texel = textureLod(sColor0, make_vec3(vUv, vLayer), 0.f);
 vec4 color = (vColor)*(texel);
 write_output(color);
}
static void set_uniform_1i(Self *self, int index, int value) {
 switch (index) {
 case 2:
  assert(0); // sColor0
  break;
 case 3:
  assert(0); // sColor1
  break;
 case 4:
  assert(0); // sColor2
  break;
 }
}
static void set_uniform_4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 2:
  assert(0); // sColor0
  break;
 case 3:
  assert(0); // sColor1
  break;
 case 4:
  assert(0); // sColor2
  break;
 }
}
static void set_uniform_matrix4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 2:
  assert(0); // sColor0
  break;
 case 3:
  assert(0); // sColor1
  break;
 case 4:
  assert(0); // sColor2
  break;
 }
}
typedef composite_vert::FlatOutputs FlatInputs;
typedef composite_vert::InterpOutputs InterpInputs;
static void read_flat_inputs(Self *self, const FlatInputs *src) {
  self->vColor = src->vColor;
  self->vLayer = src->vLayer;
}
InterpInputs interp_step;
static void read_interp_inputs(Self *self, const InterpInputs *init, const InterpInputs *step, float step_width) {
  self->vUv = init_interp(init->vUv, step->vUv);
  self->interp_step.vUv = step->vUv * step_width;
}
ALWAYS_INLINE void step_interp_inputs() {
  vUv += interp_step.vUv;
}
static void bind_textures(Self *self, composite_program *prog) {
 self->sColor0 = lookup_sampler_array(&prog->samplers.sColor0_impl, prog->samplers.sColor0_slot);
}
static bool use_discard(Self*) { return false; }
static void run(Self *self) {
 self->main();
 self->step_interp_inputs();
}
static void skip(Self* self, int chunks) {
 self->step_interp_inputs();
 while (--chunks > 0) self->step_interp_inputs();
}
composite_frag() {
 set_uniform_1i_func = (SetUniform1iFunc)&set_uniform_1i;
 set_uniform_4fv_func = (SetUniform4fvFunc)&set_uniform_4fv;
 set_uniform_matrix4fv_func = (SetUniformMatrix4fvFunc)&set_uniform_matrix4fv;
 init_batch_func = (InitBatchFunc)&bind_textures;
 init_primitive_func = (InitPrimitiveFunc)&read_flat_inputs;
 init_span_func = (InitSpanFunc)&read_interp_inputs;
 run_func = (RunFunc)&run;
 skip_func = (SkipFunc)&skip;
 use_discard_func = (UseDiscardFunc)&use_discard;
}
};

FragmentShaderImpl* composite_program::get_fragment_shader() { return new composite_frag; }
