struct composite_YUV_TEXTURE_RECT_program : ProgramImpl {
int get_uniform(const char *name) const override {
 if (strcmp("sColor0", name) == 0) { return 2; }
 if (strcmp("sColor1", name) == 0) { return 3; }
 if (strcmp("sColor2", name) == 0) { return 4; }
 if (strcmp("uTransform", name) == 0) { return 1; }
 return -1;
}
struct Samplers {
 sampler2DRect_impl sColor0_impl;
 int sColor0_slot;
 sampler2DRect_impl sColor1_impl;
 int sColor1_slot;
 sampler2DRect_impl sColor2_impl;
 int sColor2_slot;
} samplers;
bool set_sampler(int index, int value) override {
 switch (index) {
 case 2:
  samplers.sColor0_slot = value;
  return true;
 case 3:
  samplers.sColor1_slot = value;
  return true;
 case 4:
  samplers.sColor2_slot = value;
  return true;
 }
 return false;
}
struct AttribLocations {
 int aPosition = NULL_ATTRIB;
 int aDeviceRect = NULL_ATTRIB;
 int aDeviceClipRect = NULL_ATTRIB;
 int aParams = NULL_ATTRIB;
 int aTextureLayers = NULL_ATTRIB;
 int aUvRect0 = NULL_ATTRIB;
 int aUvRect1 = NULL_ATTRIB;
 int aUvRect2 = NULL_ATTRIB;
} attrib_locations;
void bind_attrib(const char* name, int index) override {
 if (strcmp("aPosition", name) == 0) { attrib_locations.aPosition = index; return; }
 if (strcmp("aDeviceRect", name) == 0) { attrib_locations.aDeviceRect = index; return; }
 if (strcmp("aDeviceClipRect", name) == 0) { attrib_locations.aDeviceClipRect = index; return; }
 if (strcmp("aParams", name) == 0) { attrib_locations.aParams = index; return; }
 if (strcmp("aTextureLayers", name) == 0) { attrib_locations.aTextureLayers = index; return; }
 if (strcmp("aUvRect0", name) == 0) { attrib_locations.aUvRect0 = index; return; }
 if (strcmp("aUvRect1", name) == 0) { attrib_locations.aUvRect1 = index; return; }
 if (strcmp("aUvRect2", name) == 0) { attrib_locations.aUvRect2 = index; return; }
}
int get_attrib(const char* name) const override {
 if (strcmp("aPosition", name) == 0) {return attrib_locations.aPosition != NULL_ATTRIB ? attrib_locations.aPosition : -1;}
 if (strcmp("aDeviceRect", name) == 0) {return attrib_locations.aDeviceRect != NULL_ATTRIB ? attrib_locations.aDeviceRect : -1;}
 if (strcmp("aDeviceClipRect", name) == 0) {return attrib_locations.aDeviceClipRect != NULL_ATTRIB ? attrib_locations.aDeviceClipRect : -1;}
 if (strcmp("aParams", name) == 0) {return attrib_locations.aParams != NULL_ATTRIB ? attrib_locations.aParams : -1;}
 if (strcmp("aTextureLayers", name) == 0) {return attrib_locations.aTextureLayers != NULL_ATTRIB ? attrib_locations.aTextureLayers : -1;}
 if (strcmp("aUvRect0", name) == 0) {return attrib_locations.aUvRect0 != NULL_ATTRIB ? attrib_locations.aUvRect0 : -1;}
 if (strcmp("aUvRect1", name) == 0) {return attrib_locations.aUvRect1 != NULL_ATTRIB ? attrib_locations.aUvRect1 : -1;}
 if (strcmp("aUvRect2", name) == 0) {return attrib_locations.aUvRect2 != NULL_ATTRIB ? attrib_locations.aUvRect2 : -1;}
  return -1;
}
VertexShaderImpl* get_vertex_shader() override;
FragmentShaderImpl* get_fragment_shader() override;
static ProgramImpl* loader() { return new composite_YUV_TEXTURE_RECT_program; }
};

struct composite_YUV_TEXTURE_RECT_vert : VertexShaderImpl {
typedef composite_YUV_TEXTURE_RECT_vert Self;
int32_t uMode;
mat4_scalar uTransform;
vec2 aPosition;
sampler2DRect sColor0;
sampler2DRect sColor1;
sampler2DRect sColor2;
mat3_scalar static constexpr YuvColorMatrixRec601 = make_mat3(1.16438f, 1.16438f, 1.16438f, 0.f, -(0.39176f), 2.01723f, 1.59603f, -(0.81297f), 0.f);
mat3_scalar static constexpr YuvColorMatrixRec709 = make_mat3(1.16438f, 1.16438f, 1.16438f, 0.f, -(0.21325f), 2.1124f, 1.79274f, -(0.53291f), 0.f);
mat3_scalar static constexpr YuvColorMatrixRec2020 = make_mat3(1.16438356164384f, 1.16438356164384f, 1.16438356164384f, 0.f, -(0.187326104219343f), 2.14177232142857f, 1.67867410714286f, -(0.650424318505057f), 0.f);
mat3_scalar vYuvColorMatrix;
float vYuvCoefficient;
int32_t vYuvFormat;
vec3 vUV_y;
vec3 vUV_u;
vec3 vUV_v;
vec4_scalar vUVBounds_y;
vec4_scalar vUVBounds_u;
vec4_scalar vUVBounds_v;
vec4_scalar aDeviceRect;
vec4_scalar aDeviceClipRect;
vec4_scalar aColor;
vec4_scalar aParams;
vec3_scalar aTextureLayers;
vec4_scalar aUvRect0;
vec4_scalar aUvRect1;
vec4_scalar aUvRect2;
mat3_scalar get_yuv_color_matrix(int32_t color_space) {
 switch (color_space) {
  case 0:
   return YuvColorMatrixRec601;
  case 1:
   return YuvColorMatrixRec709;
  default:
   return YuvColorMatrixRec2020;
 }
}
void write_uv_rect(vec2_scalar uv0, vec2_scalar uv1, float layer, vec2 f, vec2_scalar texture_size, vec3& uv, vec4_scalar& uv_bounds) {
 (uv).lsel(X, Y) = mix(uv0, uv1, f);
 (uv).sel(Z) = layer;
 uv_bounds = make_vec4((uv0)+(make_vec2(0.5f)), (uv1)-(make_vec2(0.5f)));
}
ALWAYS_INLINE void main(void) {
 vec2 world_pos = ((aDeviceRect).sel(X, Y))+(((aPosition).sel(X, Y))*((aDeviceRect).sel(Z, W)));
 vec2 clipped_world_pos = clamp(world_pos, (aDeviceClipRect).sel(X, Y), ((aDeviceClipRect).sel(X, Y))+((aDeviceClipRect).sel(Z, W)));
 vec2 uv = ((clipped_world_pos)-((aDeviceRect).sel(X, Y)))/((aDeviceRect).sel(Z, W));
 int32_t yuv_color_space = make_int((aParams).sel(Y));
 int32_t yuv_format = make_int((aParams).sel(Z));
 float yuv_coefficient = (aParams).sel(W);
 vYuvColorMatrix = get_yuv_color_matrix(yuv_color_space);
 vYuvCoefficient = yuv_coefficient;
 vYuvFormat = yuv_format;
 write_uv_rect((aUvRect0).sel(X, Y), (aUvRect0).sel(Z, W), (aTextureLayers).sel(X), uv, make_vec2(1.f), vUV_y, vUVBounds_y);
 write_uv_rect((aUvRect1).sel(X, Y), (aUvRect1).sel(Z, W), (aTextureLayers).sel(Y), uv, make_vec2(1.f), vUV_u, vUVBounds_u);
 write_uv_rect((aUvRect2).sel(X, Y), (aUvRect2).sel(Z, W), (aTextureLayers).sel(Z), uv, make_vec2(1.f), vUV_v, vUVBounds_v);
 gl_Position = (uTransform)*(make_vec4(clipped_world_pos, (aParams).sel(X), 1.f));
}
static void set_uniform_1i(Self *self, int index, int value) {
 switch (index) {
 case 1:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_matrix4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  self->uTransform = mat4_scalar::load_from_ptr(value);
  break;
 }
}
static void load_attribs(Self *self, composite_YUV_TEXTURE_RECT_program *prog, VertexAttrib *attribs, unsigned short *indices, int start, int instance, int count) {
 load_attrib(self->aPosition, attribs[prog->attrib_locations.aPosition], indices, start, instance, count);
 load_flat_attrib(self->aDeviceRect, attribs[prog->attrib_locations.aDeviceRect], indices, start, instance, count);
 load_flat_attrib(self->aDeviceClipRect, attribs[prog->attrib_locations.aDeviceClipRect], indices, start, instance, count);
 load_flat_attrib(self->aParams, attribs[prog->attrib_locations.aParams], indices, start, instance, count);
 load_flat_attrib(self->aTextureLayers, attribs[prog->attrib_locations.aTextureLayers], indices, start, instance, count);
 load_flat_attrib(self->aUvRect0, attribs[prog->attrib_locations.aUvRect0], indices, start, instance, count);
 load_flat_attrib(self->aUvRect1, attribs[prog->attrib_locations.aUvRect1], indices, start, instance, count);
 load_flat_attrib(self->aUvRect2, attribs[prog->attrib_locations.aUvRect2], indices, start, instance, count);
}
struct FlatOutputs {
mat3_scalar vYuvColorMatrix;
float vYuvCoefficient;
int32_t vYuvFormat;
vec4_scalar vUVBounds_y;
vec4_scalar vUVBounds_u;
vec4_scalar vUVBounds_v;
};
struct InterpOutputs {
vec3_scalar vUV_y;
vec3_scalar vUV_u;
vec3_scalar vUV_v;
};
ALWAYS_INLINE void store_flat_outputs(char* dest_ptr) {
  auto* dest = reinterpret_cast<FlatOutputs*>(dest_ptr);
  dest->vYuvColorMatrix = vYuvColorMatrix;
  dest->vYuvCoefficient = vYuvCoefficient;
  dest->vYuvFormat = vYuvFormat;
  dest->vUVBounds_y = vUVBounds_y;
  dest->vUVBounds_u = vUVBounds_u;
  dest->vUVBounds_v = vUVBounds_v;
}
ALWAYS_INLINE void store_interp_outputs(char* dest_ptr, size_t stride) {
  for(int n = 0; n < 4; n++) {
    auto* dest = reinterpret_cast<InterpOutputs*>(dest_ptr);
    dest->vUV_y = get_nth(vUV_y, n);
    dest->vUV_u = get_nth(vUV_u, n);
    dest->vUV_v = get_nth(vUV_v, n);
    dest_ptr += stride;
  }
}
static void bind_textures(Self *self, composite_YUV_TEXTURE_RECT_program *prog) {
}
static void run(Self* self, char* flats, char* interps, size_t interp_stride) {
 self->main();
 self->store_flat_outputs(flats);
 self->store_interp_outputs(interps, interp_stride);
}
composite_YUV_TEXTURE_RECT_vert() {
 set_uniform_1i_func = (SetUniform1iFunc)&set_uniform_1i;
 set_uniform_4fv_func = (SetUniform4fvFunc)&set_uniform_4fv;
 set_uniform_matrix4fv_func = (SetUniformMatrix4fvFunc)&set_uniform_matrix4fv;
 init_batch_func = (InitBatchFunc)&bind_textures;
 load_attribs_func = (LoadAttribsFunc)&load_attribs;
 run_func = (RunFunc)&run;
}
};

VertexShaderImpl* composite_YUV_TEXTURE_RECT_program::get_vertex_shader() { return new composite_YUV_TEXTURE_RECT_vert; }
mat3_scalar constexpr composite_YUV_TEXTURE_RECT_vert::YuvColorMatrixRec601;
mat3_scalar constexpr composite_YUV_TEXTURE_RECT_vert::YuvColorMatrixRec709;
mat3_scalar constexpr composite_YUV_TEXTURE_RECT_vert::YuvColorMatrixRec2020;

struct composite_YUV_TEXTURE_RECT_frag : FragmentShaderImpl {
typedef composite_YUV_TEXTURE_RECT_frag Self;
#define oFragColor gl_FragColor
// vec4 oFragColor;
sampler2DRect sColor0;
sampler2DRect sColor1;
sampler2DRect sColor2;
mat3_scalar vYuvColorMatrix;
float vYuvCoefficient;
int32_t vYuvFormat;
vec3 vUV_y;
vec3 vUV_u;
vec3 vUV_v;
vec4_scalar vUVBounds_y;
vec4_scalar vUVBounds_u;
vec4_scalar vUVBounds_v;
vec4 sample_yuv(int32_t format, mat3_scalar yuv_color_matrix, float coefficient, vec3 in_uv_y, vec3 in_uv_u, vec3 in_uv_v, vec4_scalar uv_bounds_y, vec4_scalar uv_bounds_u, vec4_scalar uv_bounds_v) {
 vec3 yuv_value;
 switch (format) {
  case 1:
   {
    vec2 uv_y = clamp((in_uv_y).sel(X, Y), (uv_bounds_y).sel(X, Y), (uv_bounds_y).sel(Z, W));
    vec2 uv_u = clamp((in_uv_u).sel(X, Y), (uv_bounds_u).sel(X, Y), (uv_bounds_u).sel(Z, W));
    vec2 uv_v = clamp((in_uv_v).sel(X, Y), (uv_bounds_v).sel(X, Y), (uv_bounds_v).sel(Z, W));
    (yuv_value).sel(X) = (texture(sColor0, (make_vec3(uv_y, (in_uv_y).sel(Z))).sel(X, Y))).sel(R);
    (yuv_value).sel(Y) = (texture(sColor1, (make_vec3(uv_u, (in_uv_u).sel(Z))).sel(X, Y))).sel(R);
    (yuv_value).sel(Z) = (texture(sColor2, (make_vec3(uv_v, (in_uv_v).sel(Z))).sel(X, Y))).sel(R);
   }
   break;
  case 0:
   {
    vec2 uv_y = clamp((in_uv_y).sel(X, Y), (uv_bounds_y).sel(X, Y), (uv_bounds_y).sel(Z, W));
    vec2 uv_uv = clamp((in_uv_u).sel(X, Y), (uv_bounds_u).sel(X, Y), (uv_bounds_u).sel(Z, W));
    (yuv_value).sel(X) = (texture(sColor0, (make_vec3(uv_y, (in_uv_y).sel(Z))).sel(X, Y))).sel(R);
    (yuv_value).lsel(Y, Z) = (texture(sColor1, (make_vec3(uv_uv, (in_uv_u).sel(Z))).sel(X, Y))).sel(R, G);
   }
   break;
  case 2:
   {
    vec2 uv_y = clamp((in_uv_y).sel(X, Y), (uv_bounds_y).sel(X, Y), (uv_bounds_y).sel(Z, W));
    yuv_value = (texture(sColor0, (make_vec3(uv_y, (in_uv_y).sel(Z))).sel(X, Y))).sel(G, B, R);
   }
   break;
  default:
   yuv_value = make_vec3(0.f);
   break;
 }
 vec3 rgb = (yuv_color_matrix)*(((yuv_value)*(coefficient))-(make_vec3(0.06275f, 0.50196f, 0.50196f)));
 vec4 color = make_vec4(rgb, 1.f);
 return color;
}
void write_output(vec4 color) {
 oFragColor = color;
}
ALWAYS_INLINE void main(void) {
 vec4 color = sample_yuv(vYuvFormat, vYuvColorMatrix, vYuvCoefficient, vUV_y, vUV_u, vUV_v, vUVBounds_y, vUVBounds_u, vUVBounds_v);
 write_output(color);
}
static void set_uniform_1i(Self *self, int index, int value) {
 switch (index) {
 case 2:
  assert(0); // sColor0
  break;
 case 3:
  assert(0); // sColor1
  break;
 case 4:
  assert(0); // sColor2
  break;
 }
}
static void set_uniform_4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 2:
  assert(0); // sColor0
  break;
 case 3:
  assert(0); // sColor1
  break;
 case 4:
  assert(0); // sColor2
  break;
 }
}
static void set_uniform_matrix4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 2:
  assert(0); // sColor0
  break;
 case 3:
  assert(0); // sColor1
  break;
 case 4:
  assert(0); // sColor2
  break;
 }
}
typedef composite_YUV_TEXTURE_RECT_vert::FlatOutputs FlatInputs;
typedef composite_YUV_TEXTURE_RECT_vert::InterpOutputs InterpInputs;
static void read_flat_inputs(Self *self, const FlatInputs *src) {
  self->vYuvColorMatrix = src->vYuvColorMatrix;
  self->vYuvCoefficient = src->vYuvCoefficient;
  self->vYuvFormat = src->vYuvFormat;
  self->vUVBounds_y = src->vUVBounds_y;
  self->vUVBounds_u = src->vUVBounds_u;
  self->vUVBounds_v = src->vUVBounds_v;
}
InterpInputs interp_step;
static void read_interp_inputs(Self *self, const InterpInputs *init, const InterpInputs *step, float step_width) {
  self->vUV_y = init_interp(init->vUV_y, step->vUV_y);
  self->interp_step.vUV_y = step->vUV_y * step_width;
  self->vUV_u = init_interp(init->vUV_u, step->vUV_u);
  self->interp_step.vUV_u = step->vUV_u * step_width;
  self->vUV_v = init_interp(init->vUV_v, step->vUV_v);
  self->interp_step.vUV_v = step->vUV_v * step_width;
}
ALWAYS_INLINE void step_interp_inputs() {
  vUV_y += interp_step.vUV_y;
  vUV_u += interp_step.vUV_u;
  vUV_v += interp_step.vUV_v;
}
static void bind_textures(Self *self, composite_YUV_TEXTURE_RECT_program *prog) {
 self->sColor0 = lookup_sampler(&prog->samplers.sColor0_impl, prog->samplers.sColor0_slot);
 self->sColor1 = lookup_sampler(&prog->samplers.sColor1_impl, prog->samplers.sColor1_slot);
 self->sColor2 = lookup_sampler(&prog->samplers.sColor2_impl, prog->samplers.sColor2_slot);
}
static bool use_discard(Self*) { return false; }
static void run(Self *self) {
 self->main();
 self->step_interp_inputs();
}
static void skip(Self* self, int chunks) {
 self->step_interp_inputs();
 while (--chunks > 0) self->step_interp_inputs();
}
composite_YUV_TEXTURE_RECT_frag() {
 set_uniform_1i_func = (SetUniform1iFunc)&set_uniform_1i;
 set_uniform_4fv_func = (SetUniform4fvFunc)&set_uniform_4fv;
 set_uniform_matrix4fv_func = (SetUniformMatrix4fvFunc)&set_uniform_matrix4fv;
 init_batch_func = (InitBatchFunc)&bind_textures;
 init_primitive_func = (InitPrimitiveFunc)&read_flat_inputs;
 init_span_func = (InitSpanFunc)&read_interp_inputs;
 run_func = (RunFunc)&run;
 skip_func = (SkipFunc)&skip;
 use_discard_func = (UseDiscardFunc)&use_discard;
}
};

FragmentShaderImpl* composite_YUV_TEXTURE_RECT_program::get_fragment_shader() { return new composite_YUV_TEXTURE_RECT_frag; }
