struct cs_line_decoration_program : ProgramImpl {
int get_uniform(const char *name) const override {
 if (strcmp("uTransform", name) == 0) { return 1; }
 return -1;
}
struct Samplers {
} samplers;
bool set_sampler(int index, int value) override {
 switch (index) {
 }
 return false;
}
struct AttribLocations {
 int aPosition = NULL_ATTRIB;
 int aTaskRect = NULL_ATTRIB;
 int aLocalSize = NULL_ATTRIB;
 int aStyle = NULL_ATTRIB;
 int aAxisSelect = NULL_ATTRIB;
 int aWavyLineThickness = NULL_ATTRIB;
} attrib_locations;
void bind_attrib(const char* name, int index) override {
 if (strcmp("aPosition", name) == 0) { attrib_locations.aPosition = index; return; }
 if (strcmp("aTaskRect", name) == 0) { attrib_locations.aTaskRect = index; return; }
 if (strcmp("aLocalSize", name) == 0) { attrib_locations.aLocalSize = index; return; }
 if (strcmp("aStyle", name) == 0) { attrib_locations.aStyle = index; return; }
 if (strcmp("aAxisSelect", name) == 0) { attrib_locations.aAxisSelect = index; return; }
 if (strcmp("aWavyLineThickness", name) == 0) { attrib_locations.aWavyLineThickness = index; return; }
}
int get_attrib(const char* name) const override {
 if (strcmp("aPosition", name) == 0) {return attrib_locations.aPosition != NULL_ATTRIB ? attrib_locations.aPosition : -1;}
 if (strcmp("aTaskRect", name) == 0) {return attrib_locations.aTaskRect != NULL_ATTRIB ? attrib_locations.aTaskRect : -1;}
 if (strcmp("aLocalSize", name) == 0) {return attrib_locations.aLocalSize != NULL_ATTRIB ? attrib_locations.aLocalSize : -1;}
 if (strcmp("aStyle", name) == 0) {return attrib_locations.aStyle != NULL_ATTRIB ? attrib_locations.aStyle : -1;}
 if (strcmp("aAxisSelect", name) == 0) {return attrib_locations.aAxisSelect != NULL_ATTRIB ? attrib_locations.aAxisSelect : -1;}
 if (strcmp("aWavyLineThickness", name) == 0) {return attrib_locations.aWavyLineThickness != NULL_ATTRIB ? attrib_locations.aWavyLineThickness : -1;}
  return -1;
}
VertexShaderImpl* get_vertex_shader() override;
FragmentShaderImpl* get_fragment_shader() override;
static ProgramImpl* loader() { return new cs_line_decoration_program; }
};

struct cs_line_decoration_vert : VertexShaderImpl {
typedef cs_line_decoration_vert Self;
int32_t uMode;
mat4_scalar uTransform;
vec2 aPosition;
sampler2DArray sColor0;
sampler2DArray sColor1;
sampler2DArray sColor2;
vec2 vLocalPos;
int32_t vStyle;
vec4_scalar vParams;
vec4_scalar aTaskRect;
vec2_scalar aLocalSize;
int32_t aStyle;
float aAxisSelect;
float aWavyLineThickness;
ALWAYS_INLINE void main(void) {
 vec2_scalar size = mix(aLocalSize, (aLocalSize).sel(Y, X), aAxisSelect);
 vStyle = aStyle;
 switch (vStyle) {
  case 0:
   {
    break;
   }
  case 2:
   {
    vParams = make_vec4((size).sel(X), (0.5f)*((size).sel(X)), 0.f, 0.f);
    break;
   }
  case 1:
   {
    float diameter = (size).sel(Y);
    float period = (diameter)*(2.f);
    float center_line = (0.5f)*((size).sel(Y));
    vParams = make_vec4(period, (diameter)/(2.f), center_line, 0.f);
    break;
   }
  case 3:
   {
    float line_thickness = max(aWavyLineThickness, 1.f);
    float slope_length = ((size).sel(Y))-(line_thickness);
    float flat_length = max(((line_thickness)-(1.f))*(2.f), 1.f);
    vParams = make_vec4((line_thickness)/(2.f), slope_length, flat_length, (size).sel(Y));
    break;
   }
  default:
   vParams = make_vec4(0.f);
 }
 vLocalPos = (mix((aPosition).sel(X, Y), (aPosition).sel(Y, X), aAxisSelect))*(size);
 gl_Position = (uTransform)*(make_vec4(((aTaskRect).sel(X, Y))+(((aTaskRect).sel(Z, W))*((aPosition).sel(X, Y))), 0.f, 1.f));
}
static void set_uniform_1i(Self *self, int index, int value) {
 switch (index) {
 case 1:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_matrix4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  self->uTransform = mat4_scalar::load_from_ptr(value);
  break;
 }
}
static void load_attribs(Self *self, cs_line_decoration_program *prog, VertexAttrib *attribs, unsigned short *indices, int start, int instance, int count) {
 load_attrib(self->aPosition, attribs[prog->attrib_locations.aPosition], indices, start, instance, count);
 load_flat_attrib(self->aTaskRect, attribs[prog->attrib_locations.aTaskRect], indices, start, instance, count);
 load_flat_attrib(self->aLocalSize, attribs[prog->attrib_locations.aLocalSize], indices, start, instance, count);
 load_flat_attrib(self->aStyle, attribs[prog->attrib_locations.aStyle], indices, start, instance, count);
 load_flat_attrib(self->aAxisSelect, attribs[prog->attrib_locations.aAxisSelect], indices, start, instance, count);
 load_flat_attrib(self->aWavyLineThickness, attribs[prog->attrib_locations.aWavyLineThickness], indices, start, instance, count);
}
struct FlatOutputs {
int32_t vStyle;
vec4_scalar vParams;
};
struct InterpOutputs {
vec2_scalar vLocalPos;
};
ALWAYS_INLINE void store_flat_outputs(char* dest_ptr) {
  auto* dest = reinterpret_cast<FlatOutputs*>(dest_ptr);
  dest->vStyle = vStyle;
  dest->vParams = vParams;
}
ALWAYS_INLINE void store_interp_outputs(char* dest_ptr, size_t stride) {
  for(int n = 0; n < 4; n++) {
    auto* dest = reinterpret_cast<InterpOutputs*>(dest_ptr);
    dest->vLocalPos = get_nth(vLocalPos, n);
    dest_ptr += stride;
  }
}
static void bind_textures(Self *self, cs_line_decoration_program *prog) {
}
static void run(Self* self, char* flats, char* interps, size_t interp_stride) {
 self->main();
 self->store_flat_outputs(flats);
 self->store_interp_outputs(interps, interp_stride);
}
cs_line_decoration_vert() {
 set_uniform_1i_func = (SetUniform1iFunc)&set_uniform_1i;
 set_uniform_4fv_func = (SetUniform4fvFunc)&set_uniform_4fv;
 set_uniform_matrix4fv_func = (SetUniformMatrix4fvFunc)&set_uniform_matrix4fv;
 init_batch_func = (InitBatchFunc)&bind_textures;
 load_attribs_func = (LoadAttribsFunc)&load_attribs;
 run_func = (RunFunc)&run;
}
};

VertexShaderImpl* cs_line_decoration_program::get_vertex_shader() { return new cs_line_decoration_vert; }

struct cs_line_decoration_frag : FragmentShaderImpl {
typedef cs_line_decoration_frag Self;
#define oFragColor gl_FragColor
// vec4 oFragColor;
sampler2DArray sColor0;
sampler2DArray sColor1;
sampler2DArray sColor2;
vec2 vLocalPos;
int32_t vStyle;
vec4_scalar vParams;
Float compute_aa_range(vec2 position) {
 return (0.35355f)*(length(fwidth(position)));
}
Float distance_aa(Float aa_range, Float signed_distance) {
 I32 ret_mask = ~0;
 Float ret;
 Float dist = ((0.5f)*(signed_distance))/(aa_range);
 auto _c3_ = (dist)<=((-(0.5f))+(0.0001f));
 ret = 1.f;
 ret_mask = ~I32(_c3_);
 auto _c4_ = (dist)>=((0.5f)-(0.0001f));
 ret = if_then_else(ret_mask & I32(_c4_), 0.f, ret);
 ret_mask &= ~I32(_c4_);
 ret = if_then_else(ret_mask, (0.5f)+((dist)*((((0.8431027f)*(dist))*(dist))-(1.14453603f))), ret);
 return ret;
}
Float distance_to_line(vec2 p0, vec2 perp_dir, vec2 p) {
 vec2 dir_to_p0 = (p0)-(p);
 return dot(normalize(perp_dir), dir_to_p0);
}
ALWAYS_INLINE void main(void) {
 vec2 pos = vLocalPos;
 Float aa_range = compute_aa_range(pos);
 Float alpha = 1.f;
 switch (vStyle) {
  case 0:
   {
    break;
   }
  case 2:
   {
    alpha = step(floor(((pos).sel(X))+(0.5f)), (vParams).sel(Y));
    break;
   }
  case 1:
   {
    vec2 dot_relative_pos = (pos)-((vParams).sel(Y, Z));
    Float dot_distance = (length(dot_relative_pos))-((vParams).sel(Y));
    alpha = distance_aa(aa_range, dot_distance);
    break;
   }
  case 3:
   {
    float half_line_thickness = (vParams).sel(X);
    float slope_length = (vParams).sel(Y);
    float flat_length = (vParams).sel(Z);
    float vertical_bounds = (vParams).sel(W);
    float half_period = (slope_length)+(flat_length);
    float mid_height = (vertical_bounds)/(2.f);
    Float peak_offset = (mid_height)-(half_line_thickness);
    Float flip = (-(2.f))*((step(mod((pos).sel(X), (2.f)*(half_period)), half_period))-(0.5f));
    peak_offset *= flip;
    Float peak_height = (mid_height)+(peak_offset);
    (pos).sel(X) = mod((pos).sel(X), half_period);
    Float dist1 = distance_to_line(make_vec2(0.f, peak_height), make_vec2(1.f, -(flip)), pos);
    Float dist2 = distance_to_line(make_vec2(0.f, peak_height), make_vec2(0, -(flip)), pos);
    Float dist3 = distance_to_line(make_vec2(flat_length, peak_height), make_vec2(-(1.f), -(flip)), pos);
    Float dist = abs(max(max(dist1, dist2), dist3));
    alpha = distance_aa(aa_range, (dist)-(half_line_thickness));
    if ((half_line_thickness)<=(1.f)) {
     {
      alpha = (1.f)-(step(alpha, 0.5f));
     }
    }
    break;
   }
  default:
   break;
 }
 oFragColor = make_vec4(alpha);
}
static void set_uniform_1i(Self *self, int index, int value) {
 switch (index) {
 }
}
static void set_uniform_4fv(Self *self, int index, const float *value) {
 switch (index) {
 }
}
static void set_uniform_matrix4fv(Self *self, int index, const float *value) {
 switch (index) {
 }
}
typedef cs_line_decoration_vert::FlatOutputs FlatInputs;
typedef cs_line_decoration_vert::InterpOutputs InterpInputs;
static void read_flat_inputs(Self *self, const FlatInputs *src) {
  self->vStyle = src->vStyle;
  self->vParams = src->vParams;
}
InterpInputs interp_step;
static void read_interp_inputs(Self *self, const InterpInputs *init, const InterpInputs *step, float step_width) {
  self->vLocalPos = init_interp(init->vLocalPos, step->vLocalPos);
  self->interp_step.vLocalPos = step->vLocalPos * step_width;
}
ALWAYS_INLINE void step_interp_inputs() {
  vLocalPos += interp_step.vLocalPos;
}
static void bind_textures(Self *self, cs_line_decoration_program *prog) {
}
static bool use_discard(Self*) { return false; }
static void run(Self *self) {
 self->main();
 self->step_interp_inputs();
}
static void skip(Self* self, int chunks) {
 self->step_interp_inputs();
 while (--chunks > 0) self->step_interp_inputs();
}
cs_line_decoration_frag() {
 set_uniform_1i_func = (SetUniform1iFunc)&set_uniform_1i;
 set_uniform_4fv_func = (SetUniform4fvFunc)&set_uniform_4fv;
 set_uniform_matrix4fv_func = (SetUniformMatrix4fvFunc)&set_uniform_matrix4fv;
 init_batch_func = (InitBatchFunc)&bind_textures;
 init_primitive_func = (InitPrimitiveFunc)&read_flat_inputs;
 init_span_func = (InitSpanFunc)&read_interp_inputs;
 run_func = (RunFunc)&run;
 skip_func = (SkipFunc)&skip;
 use_discard_func = (UseDiscardFunc)&use_discard;
}
};

FragmentShaderImpl* cs_line_decoration_program::get_fragment_shader() { return new cs_line_decoration_frag; }
