#include "ps_text_run_ALPHA_PASS.h"
#include "ps_text_run_GLYPH_TRANSFORM_ALPHA_PASS.h"
#include "ps_text_run_DEBUG_OVERDRAW.h"
#include "ps_text_run_DUAL_SOURCE_BLENDING_ALPHA_PASS.h"
#include "ps_text_run_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_ALPHA_PASS.h"
#include "ps_text_run_DUAL_SOURCE_BLENDING_DEBUG_OVERDRAW.h"
#include "cs_border_solid.h"
#include "composite.h"
#include "composite_YUV.h"
#include "composite_YUV_TEXTURE_2D.h"
#include "composite_YUV_TEXTURE_RECT.h"
#include "cs_border_segment.h"
#include "brush_yuv_image_YUV.h"
#include "brush_yuv_image_YUV_ALPHA_PASS.h"
#include "brush_yuv_image_YUV_DEBUG_OVERDRAW.h"
#include "brush_yuv_image_YUV_TEXTURE_2D.h"
#include "brush_yuv_image_YUV_TEXTURE_2D_ALPHA_PASS.h"
#include "brush_yuv_image_YUV_TEXTURE_2D_DEBUG_OVERDRAW.h"
#include "brush_yuv_image_YUV_TEXTURE_RECT.h"
#include "brush_yuv_image_YUV_TEXTURE_RECT_ALPHA_PASS.h"
#include "brush_yuv_image_YUV_TEXTURE_RECT_DEBUG_OVERDRAW.h"
#include "brush_blend.h"
#include "brush_blend_ALPHA_PASS.h"
#include "brush_blend_DEBUG_OVERDRAW.h"
#include "cs_clip_box_shadow.h"
#include "brush_mix_blend.h"
#include "brush_mix_blend_ALPHA_PASS.h"
#include "brush_mix_blend_DEBUG_OVERDRAW.h"
#include "brush_opacity.h"
#include "brush_opacity_ALPHA_PASS.h"
#include "brush_opacity_DEBUG_OVERDRAW.h"
#include "ps_split_composite.h"
#include "cs_clip_image.h"
#include "brush_solid.h"
#include "brush_solid_ALPHA_PASS.h"
#include "brush_solid_DEBUG_OVERDRAW.h"
#include "cs_gradient.h"
#include "brush_image.h"
#include "brush_image_ALPHA_PASS.h"
#include "brush_image_DEBUG_OVERDRAW.h"
#include "brush_image_REPETITION_ANTIALIASING.h"
#include "brush_image_REPETITION_ANTIALIASING_ALPHA_PASS.h"
#include "brush_image_REPETITION_ANTIALIASING_DEBUG_OVERDRAW.h"
#include "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING.h"
#include "brush_image_REPETITION_ANTIALIASING_ALPHA_PASS_DUAL_SOURCE_BLENDING.h"
#include "brush_image_TEXTURE_2D.h"
#include "brush_image_TEXTURE_2D_ALPHA_PASS.h"
#include "brush_image_TEXTURE_2D_DEBUG_OVERDRAW.h"
#include "brush_image_TEXTURE_2D_REPETITION_ANTIALIASING.h"
#include "brush_image_TEXTURE_2D_REPETITION_ANTIALIASING_ALPHA_PASS.h"
#include "brush_image_TEXTURE_2D_REPETITION_ANTIALIASING_DEBUG_OVERDRAW.h"
#include "brush_image_TEXTURE_2D_ALPHA_PASS_DUAL_SOURCE_BLENDING.h"
#include "brush_image_TEXTURE_2D_REPETITION_ANTIALIASING_ALPHA_PASS_DUAL_SOURCE_BLENDING.h"
#include "brush_image_TEXTURE_RECT.h"
#include "brush_image_TEXTURE_RECT_ALPHA_PASS.h"
#include "brush_image_TEXTURE_RECT_DEBUG_OVERDRAW.h"
#include "brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING.h"
#include "brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING_ALPHA_PASS.h"
#include "brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING_DEBUG_OVERDRAW.h"
#include "brush_image_TEXTURE_RECT_ALPHA_PASS_DUAL_SOURCE_BLENDING.h"
#include "brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING_ALPHA_PASS_DUAL_SOURCE_BLENDING.h"
#include "cs_blur_ALPHA_TARGET.h"
#include "cs_blur_COLOR_TARGET.h"
#include "cs_clip_rectangle.h"
#include "cs_clip_rectangle_FAST_PATH.h"
#include "cs_svg_filter.h"
#include "cs_line_decoration.h"
#include "brush_radial_gradient.h"
#include "brush_radial_gradient_ALPHA_PASS.h"
#include "brush_radial_gradient_DEBUG_OVERDRAW.h"
#include "cs_scale.h"
#include "brush_conic_gradient.h"
#include "brush_conic_gradient_ALPHA_PASS.h"
#include "brush_conic_gradient_DEBUG_OVERDRAW.h"
#include "brush_linear_gradient.h"
#include "brush_linear_gradient_ALPHA_PASS.h"
#include "brush_linear_gradient_DEBUG_OVERDRAW.h"
ProgramLoader load_shader(const char* name) {
  if (!strcmp(name, "ps_text_run_ALPHA_PASS")) { return ps_text_run_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "ps_text_run_GLYPH_TRANSFORM_ALPHA_PASS")) { return ps_text_run_GLYPH_TRANSFORM_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "ps_text_run_DEBUG_OVERDRAW")) { return ps_text_run_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "ps_text_run_DUAL_SOURCE_BLENDING_ALPHA_PASS")) { return ps_text_run_DUAL_SOURCE_BLENDING_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "ps_text_run_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_ALPHA_PASS")) { return ps_text_run_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "ps_text_run_DUAL_SOURCE_BLENDING_DEBUG_OVERDRAW")) { return ps_text_run_DUAL_SOURCE_BLENDING_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "cs_border_solid")) { return cs_border_solid_program::loader; }
  if (!strcmp(name, "composite")) { return composite_program::loader; }
  if (!strcmp(name, "composite_YUV")) { return composite_YUV_program::loader; }
  if (!strcmp(name, "composite_YUV_TEXTURE_2D")) { return composite_YUV_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "composite_YUV_TEXTURE_RECT")) { return composite_YUV_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "cs_border_segment")) { return cs_border_segment_program::loader; }
  if (!strcmp(name, "brush_yuv_image_YUV")) { return brush_yuv_image_YUV_program::loader; }
  if (!strcmp(name, "brush_yuv_image_YUV_ALPHA_PASS")) { return brush_yuv_image_YUV_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_yuv_image_YUV_DEBUG_OVERDRAW")) { return brush_yuv_image_YUV_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_yuv_image_YUV_TEXTURE_2D")) { return brush_yuv_image_YUV_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_yuv_image_YUV_TEXTURE_2D_ALPHA_PASS")) { return brush_yuv_image_YUV_TEXTURE_2D_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_yuv_image_YUV_TEXTURE_2D_DEBUG_OVERDRAW")) { return brush_yuv_image_YUV_TEXTURE_2D_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_yuv_image_YUV_TEXTURE_RECT")) { return brush_yuv_image_YUV_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_yuv_image_YUV_TEXTURE_RECT_ALPHA_PASS")) { return brush_yuv_image_YUV_TEXTURE_RECT_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_yuv_image_YUV_TEXTURE_RECT_DEBUG_OVERDRAW")) { return brush_yuv_image_YUV_TEXTURE_RECT_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_blend")) { return brush_blend_program::loader; }
  if (!strcmp(name, "brush_blend_ALPHA_PASS")) { return brush_blend_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_blend_DEBUG_OVERDRAW")) { return brush_blend_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "cs_clip_box_shadow")) { return cs_clip_box_shadow_program::loader; }
  if (!strcmp(name, "brush_mix_blend")) { return brush_mix_blend_program::loader; }
  if (!strcmp(name, "brush_mix_blend_ALPHA_PASS")) { return brush_mix_blend_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_mix_blend_DEBUG_OVERDRAW")) { return brush_mix_blend_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_opacity")) { return brush_opacity_program::loader; }
  if (!strcmp(name, "brush_opacity_ALPHA_PASS")) { return brush_opacity_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_opacity_DEBUG_OVERDRAW")) { return brush_opacity_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "ps_split_composite")) { return ps_split_composite_program::loader; }
  if (!strcmp(name, "cs_clip_image")) { return cs_clip_image_program::loader; }
  if (!strcmp(name, "brush_solid")) { return brush_solid_program::loader; }
  if (!strcmp(name, "brush_solid_ALPHA_PASS")) { return brush_solid_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_solid_DEBUG_OVERDRAW")) { return brush_solid_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "cs_gradient")) { return cs_gradient_program::loader; }
  if (!strcmp(name, "brush_image")) { return brush_image_program::loader; }
  if (!strcmp(name, "brush_image_ALPHA_PASS")) { return brush_image_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_image_DEBUG_OVERDRAW")) { return brush_image_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_image_REPETITION_ANTIALIASING")) { return brush_image_REPETITION_ANTIALIASING_program::loader; }
  if (!strcmp(name, "brush_image_REPETITION_ANTIALIASING_ALPHA_PASS")) { return brush_image_REPETITION_ANTIALIASING_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_image_REPETITION_ANTIALIASING_DEBUG_OVERDRAW")) { return brush_image_REPETITION_ANTIALIASING_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING")) { return brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_program::loader; }
  if (!strcmp(name, "brush_image_REPETITION_ANTIALIASING_ALPHA_PASS_DUAL_SOURCE_BLENDING")) { return brush_image_REPETITION_ANTIALIASING_ALPHA_PASS_DUAL_SOURCE_BLENDING_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_2D")) { return brush_image_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_2D_ALPHA_PASS")) { return brush_image_TEXTURE_2D_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_2D_DEBUG_OVERDRAW")) { return brush_image_TEXTURE_2D_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_2D_REPETITION_ANTIALIASING")) { return brush_image_TEXTURE_2D_REPETITION_ANTIALIASING_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_2D_REPETITION_ANTIALIASING_ALPHA_PASS")) { return brush_image_TEXTURE_2D_REPETITION_ANTIALIASING_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_2D_REPETITION_ANTIALIASING_DEBUG_OVERDRAW")) { return brush_image_TEXTURE_2D_REPETITION_ANTIALIASING_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_2D_ALPHA_PASS_DUAL_SOURCE_BLENDING")) { return brush_image_TEXTURE_2D_ALPHA_PASS_DUAL_SOURCE_BLENDING_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_2D_REPETITION_ANTIALIASING_ALPHA_PASS_DUAL_SOURCE_BLENDING")) { return brush_image_TEXTURE_2D_REPETITION_ANTIALIASING_ALPHA_PASS_DUAL_SOURCE_BLENDING_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_RECT")) { return brush_image_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_RECT_ALPHA_PASS")) { return brush_image_TEXTURE_RECT_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_RECT_DEBUG_OVERDRAW")) { return brush_image_TEXTURE_RECT_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING")) { return brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING_ALPHA_PASS")) { return brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING_DEBUG_OVERDRAW")) { return brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_RECT_ALPHA_PASS_DUAL_SOURCE_BLENDING")) { return brush_image_TEXTURE_RECT_ALPHA_PASS_DUAL_SOURCE_BLENDING_program::loader; }
  if (!strcmp(name, "brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING_ALPHA_PASS_DUAL_SOURCE_BLENDING")) { return brush_image_TEXTURE_RECT_REPETITION_ANTIALIASING_ALPHA_PASS_DUAL_SOURCE_BLENDING_program::loader; }
  if (!strcmp(name, "cs_blur_ALPHA_TARGET")) { return cs_blur_ALPHA_TARGET_program::loader; }
  if (!strcmp(name, "cs_blur_COLOR_TARGET")) { return cs_blur_COLOR_TARGET_program::loader; }
  if (!strcmp(name, "cs_clip_rectangle")) { return cs_clip_rectangle_program::loader; }
  if (!strcmp(name, "cs_clip_rectangle_FAST_PATH")) { return cs_clip_rectangle_FAST_PATH_program::loader; }
  if (!strcmp(name, "cs_svg_filter")) { return cs_svg_filter_program::loader; }
  if (!strcmp(name, "cs_line_decoration")) { return cs_line_decoration_program::loader; }
  if (!strcmp(name, "brush_radial_gradient")) { return brush_radial_gradient_program::loader; }
  if (!strcmp(name, "brush_radial_gradient_ALPHA_PASS")) { return brush_radial_gradient_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_radial_gradient_DEBUG_OVERDRAW")) { return brush_radial_gradient_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "cs_scale")) { return cs_scale_program::loader; }
  if (!strcmp(name, "brush_conic_gradient")) { return brush_conic_gradient_program::loader; }
  if (!strcmp(name, "brush_conic_gradient_ALPHA_PASS")) { return brush_conic_gradient_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_conic_gradient_DEBUG_OVERDRAW")) { return brush_conic_gradient_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_linear_gradient")) { return brush_linear_gradient_program::loader; }
  if (!strcmp(name, "brush_linear_gradient_ALPHA_PASS")) { return brush_linear_gradient_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_linear_gradient_DEBUG_OVERDRAW")) { return brush_linear_gradient_DEBUG_OVERDRAW_program::loader; }
  return nullptr;
}
